## Domo [⎧ː̊ːːː̊⎫](http://www.nhk.or.jp/domo/) v1.0

Compact micro-framework / library for web applications:
*Domo is not afraid of
[big trees](https://www.youtube.com/watch?v=1bi24L7ryug)!*

Includes three components:
- {@link dom}: main object, contains an {@link dom *extended*}
  [JsonML](http://www.jsonml.org/) parser
  for concise XML/HTML DOM generation from Javascript,
  and element retrieval shortcuts by identifier or CSS selector.
- {@link dom.Nexus}: bidirectional binding utility
  to build HTML components and keep them synchronized with a model,
  which is just a plain Javascript object.
- {@link dom.XPath}: convenience XPath functions.
  This depends on the browser's XPath implementation,
  see {@link https://developer.mozilla.org/en-US/docs/Web/XPath}

It does not include a virtual DOM engine:
I recommend using [Mithril.js](http://mithril.js.org) instead for applications
where that approach fits better.

It also assumes a
[modern (ES5) web browser](http://kangax.github.io/compat-table/es5/#test-Object/array_literal_extensions_Reserved_words_as_property_names),
and is distributed under the [MIT](https://opensource.org/licenses/MIT) license.

The minimized version [dom.min.js](dom.min.js)
is 3.7 KB, or 1.7 KB once compressed with GZIP.

## Examples

- [simple-dom.html](examples/simple-dom.html)
  is a simple example of HTML generation with hand-made
  unidirectional binding using standard event handling.
- [bind.html](examples/bind.html)
  shows the usage of Nexus components and
  bi-directional data binding between the model and input elements.
- [dict.html](examples/dict.html)
  is a dictionary that uses all the features:
  JsonML, `XPath`, `iterateAsync`, `Nexus.addListener`, etc.
- [html-editor.html](examples/html-editor.html)
  is the simplistic HTML editor from the {@link Nexus} documentation.
