var model = { thingsSaid: "" };

// Set some attributes in the <body> tag:
dom([ document.body, { "style": "font-family:sans-serif" } ])

// Styles can be attributes as above, or CSS rules in a <style> element:
dom([
    document.body, // Insert rest as attributes/children of document.body.
    ["style", { "type":"text/css" }, "section { margin:1em; }"]
]);

// Here we get the document title from the <title> tag, and replace the
// contents of the <h1> tag inside the <header> with it:
dom([ dom.clear(dom.$('header > h1')), document.title ]);

dom([
    dom.id("main"),
    // If the value of an attribute is a function, it is assumed to be
    // an event handler. The "on" prefix in the attribute name is optional.
    ["section",
     ["p", "This is just an example."],
     ["input", {
         "oninput": function (event) {
             model.thingsSaid = event.target.value;
             dom.id("echo").textContent = model.thingsSaid;
         },
         "value": model.thingsSaid,
         "autofocus": true,
         "placeholder": "Plase, tell me something."
     }],
    ],
    ["section",
     ["button", {
         "onclick": function (event) {
             if (model.thingsSaid) {
                 alert("It has been said that " + model.thingsSaid);
             } else {
                 alert("I do not have anything good to say.");
             }
         }
     }, "Do not click!"]
    ],
    ["section", "You said: ", ["b#echo"] ]
]);

// Add a timestamp:
dom([
    dom.$("footer"),
    "Last updated: ", (new Date()).toISOString().replace(/T.*/, '')
]);
