// Author: Alberto González Palomo http://sentido-labs.com
// ©2018 Alberto González Palomo http://sentido-labs.com

var Tachions = (function () {
    var API = {};

    var transitionDuration = '0.5s';

    function update(view, nexus, property, allValues)
    {
        var newState = nexus.model[property];
        allValues.forEach(function (state) {
            if (state && state !== newState) view.classList.remove(state);
        });
        if (newState) view.classList.add(newState);
    }

    function waitFrames(frames, callback)
    {
        requestAnimationFrame(function () {
            if (frames > 0) waitFrames(frames - 1, callback);
            else            callback();
        });
    }

    API.Button = {
        new: function Button(property, transitions, nexus) {
            return this.use(dom(["button", {"name":property} ]),
                            transitions, nexus);
        },
        use: function Button(view, transitions, nexus) {
            view.classList.add('');
            var property = view.name;
            if (!property || !nexus) return view;

            var allValues = [];
            nexus.addListener(property, function (model, property, origin) {
                update(view, nexus, property, allValues);
            });
            if (!transitions) return view;

            Object.keys(transitions).forEach(function (eventName) {
                var states = transitions[eventName];
                if ('string' === typeof states) states = ["", states];
                view.addEventListener(eventName, function cycle(event) {
                    var state = nexus.model[property];
                    var index = states.indexOf(state);
                    if (index >= 0) {
                        nexus.model[property] = states[(index + 1)
                                                       % states.length];
                        nexus.changed(property);
                    }
                });
                states.forEach(function (state) {
                    if (allValues.indexOf(state) < 0) allValues.push(state);
                });
            });
            return view;
        }
    };

    return API;
});
